clc
clear all

addpath(genpath('Data'))
addpath(genpath('library'))

% Baseline
irfhorizon=10;
lb=16;
uu=84;
vars={'GDP', 'HICP', 'emp' ,  'wages', 'stock prices', 'GINI'};
vars=vars(1:end);
tt=length(vars);
L=1;
resultoutput_base=counter_model_v0(1);
temp_base=resultoutput_base(:,:,end);
temp1_base=squeeze(prctile(temp_base,[50 lb uu],1))';
temp2_base= temp1_base(L+1:L+irfhorizon,:);
impulse1_base=temp2_base(:,1);

% No labor
resultoutput_no_labor=counter_model_v0(16);
% No stock
resultoutput_no_stock=counter_model_v0(161);
% No labor and stock
resultoutput_no_labor_stock=counter_model_v0(162);


out_no_labor=resultoutput_base(:,:,end)-resultoutput_no_labor(:,:,end);


figure(6)
  
subplot(2,3,1)
temp=resultoutput_no_labor(:,:,end);
temp1=squeeze(prctile(temp,[50 lb uu],1))';
temp2= temp1(L+1:L+irfhorizon,:);
IRFLB68=   temp2(:,2);
IRFUB68=temp2(:,3);
impulse1=temp2(:,1);

x = 1:irfhorizon;
zeroline = zeros(irfhorizon,1);
plot(IRFLB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on
plot(IRFUB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on;
ha=shadedplot(x, IRFUB68', IRFLB68', [0.7 0.7 0.7],[0.7 0.7 0.7]);
hold on;
plot(impulse1,'-','Color',[0 0 0],'LineWidth',2);
hold on
plot(impulse1_base,'r--','LineWidth',2);
ylabel('Percent');
hold on;
plot(zeroline(1:irfhorizon),':k')
title('No labor market variables')
axis tight

subplot(2,3,4)
temp=out_no_labor(:,:,end);
temp1=squeeze(prctile(temp,[50 lb uu],1))';
temp2= temp1(L+1:L+irfhorizon,:);
IRFLB68=   temp2(:,2);
IRFUB68=temp2(:,3);
impulse1=temp2(:,1);

x = 1:irfhorizon;
zeroline = zeros(irfhorizon,1);
plot(IRFLB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on
plot(IRFUB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on;
ha=shadedplot(x, IRFUB68', IRFLB68', [0.7 0.7 0.7],[0.7 0.7 0.7]);
hold on;
plot(impulse1,'-','Color',[0 0 0],'LineWidth',2);
ylabel('Percent');
hold on;
plot(zeroline(1:irfhorizon),':k')
title('Differences')
axis tight
  %%
out_no_stock=resultoutput_base(:,:,end)-resultoutput_no_stock(:,:,end);

 
subplot(2,3,2)
temp=resultoutput_no_stock(:,:,end);
temp1=squeeze(prctile(temp,[50 lb uu],1))';
temp2= temp1(L+1:L+irfhorizon,:);
IRFLB68=   temp2(:,2);
IRFUB68=temp2(:,3);
impulse1=temp2(:,1);

x = 1:irfhorizon;
zeroline = zeros(irfhorizon,1);
plot(IRFLB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on
plot(IRFUB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on;
ha=shadedplot(x, IRFUB68', IRFLB68', [0.7 0.7 0.7],[0.7 0.7 0.7]);
hold on;
plot(impulse1,'-','Color',[0 0 0],'LineWidth',2);
hold on
plot(impulse1_base,'r--','LineWidth',2);
ylabel('Percent');
hold on;
plot(zeroline(1:irfhorizon),':k')
title('No Stock Prices')
axis tight
  

subplot(2,3,5)
temp=out_no_stock(:,:,end);
temp1=squeeze(prctile(temp,[50 lb uu],1))';
temp2= temp1(L+1:L+irfhorizon,:);
IRFLB68=   temp2(:,2);
IRFUB68=temp2(:,3);
impulse1=temp2(:,1);

x = 1:irfhorizon;
zeroline = zeros(irfhorizon,1);
plot(IRFLB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on
plot(IRFUB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on;
ha=shadedplot(x, IRFUB68', IRFLB68', [0.7 0.7 0.7],[0.7 0.7 0.7]);
hold on;
plot(impulse1,'-','Color',[0 0 0],'LineWidth',2);
ylabel('Percent');
hold on;
plot(zeroline(1:irfhorizon),':k')
title('Differences')
axis tight
 
  out_no_labor_stock=resultoutput_base(:,:,end)-resultoutput_no_labor_stock(:,:,end);

subplot(2,3,3)
temp=resultoutput_no_labor_stock(:,:,end);
temp1=squeeze(prctile(temp,[50 lb uu],1))';
temp2= temp1(L+1:L+irfhorizon,:);
IRFLB68=   temp2(:,2);
IRFUB68=temp2(:,3);
impulse1=temp2(:,1);

x = 1:irfhorizon;
zeroline = zeros(irfhorizon,1);
plot(IRFLB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on
plot(IRFUB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on;
ha=shadedplot(x, IRFUB68', IRFLB68', [0.7 0.7 0.7],[0.7 0.7 0.7]);
hold on;
plot(impulse1,'-','Color',[0 0 0],'LineWidth',2);
hold on
plot(impulse1_base,'r--','LineWidth',2);
ylabel('Percent');
hold on;
plot(zeroline(1:irfhorizon),':k')
title('No Labor market vars and Stock Prices')
axis tight
  


subplot(2,3,6)
temp=out_no_labor_stock(:,:,end);
temp1=squeeze(prctile(temp,[50 lb uu],1))';
temp2= temp1(L+1:L+irfhorizon,:);
IRFLB68=   temp2(:,2);
IRFUB68=temp2(:,3);
impulse1=temp2(:,1);

x = 1:irfhorizon;
zeroline = zeros(irfhorizon,1);
plot(IRFLB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on
plot(IRFUB68,'LineStyle',':','Color',[0 0 0],'LineWidth',1.5);
hold on;
ha=shadedplot(x, IRFUB68', IRFLB68', [0.7 0.7 0.7],[0.7 0.7 0.7]);
hold on;
plot(impulse1,'-','Color',[0 0 0],'LineWidth',2);
ylabel('Percent');
hold on;
plot(zeroline(1:irfhorizon),':k')
title('Differences')
axis tight

  
