function [yd,xd,b0,s0]=getdummiesSS_v2(LAMDAPEVIEWS,TAUPEVIEWS,EPSILONPEVIEWS,Y,L,EX,LH,EPSILONH,RW,Q,epsilon2)
N=cols(Y);

lamdaP=LAMDAPEVIEWS;  %This controls the tightness of the priors on the first lag
tauP=TAUPEVIEWS;  % this controls the tightness of the priors on sum of coefficients
epsilonP=EPSILONPEVIEWS;  % this controls tightness of the prior on the constant
epsilonH=EPSILONH;
muP=mean(Y)';
sigmaP=zeros(N,1);
deltaP=zeros(N,1);

for i=1:N
    ytemp=Y(:,i);
    xtemp=[];
    for lag=1:L
    xtemp=[xtemp lag0(ytemp,lag)];
    end
    xtemp=[xtemp ones(rows(ytemp),1)];
    ytemp=ytemp(L+1:end,:);
    xtemp=xtemp(L+1:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if btemp(1)>1;
        btemp(1)=1;
    end
    sigmaP(i)=sqrt(stemp);
    deltaP(i)=btemp(1);
end




if RW==1
    deltaP=ones(N,1);
end
[yd,xd] = create_dummies_set(lamdaP,tauP,deltaP,epsilonP,epsilon2,L,muP,sigmaP,N,EX,Q);
b0=[];
s0=[];



function [y,x] = create_dummies_set(lamda,tau,delta,epsilon,epsilon2,p,mu,sigma,n,EX,Q)

% Initialise output (necessary for final concatenation to work when tau=0):
x = [];
y = [];
yd1 = [];
yd2 = [];
xd1 = [];
xd2 = [];

%% Get dummy matrices in equation (5) of Banbura et al. 2007:
if lamda>0
    if epsilon >0
	yd1=[diag(sigma.*delta)./lamda;
         zeros(n*(p-1),n);
         diag(sigma);
         zeros(EX,n)];
     
	jp=diag(1:p);
    
	xd1=[kron(jp,diag(sigma)./lamda) zeros((n*p),EX);
         zeros(n,(n*p)+EX);
         zeros(EX-Q,n*p) epsilon*eye(EX-Q) zeros(EX-Q,Q);
        zeros(Q,n*p) zeros(Q,EX-Q)  epsilon2*eye(Q) ];
   

else
    
   yd1=[diag(sigma.*delta)./lamda;
         zeros(n*(p-1),n);
         diag(sigma)];
     
	jp=diag(1:p);
    
	xd1=[kron(jp,diag(sigma)./lamda);
         zeros(n,(n*p))]; 
    end
end
%% Get additional dummy matrices - see equation (9) of Banbura et al. 2007:
if tau>0
    if epsilon>0
	yd2=diag(delta.*mu)./tau;
	xd2=[kron(ones(1,p),yd2) zeros(n,EX)];  %EX
    else
      yd2=diag(delta.*mu)./tau;
	xd2=[kron(ones(1,p),yd2)];  
    end
end
     
%% 
y=[yd1;yd2];
x=[xd1;xd2];
 
         
 
 