clear

addpath('../functions');
dfolder='../data/';
sfolder='./results/';
parpool(4)
HORZ=48;
fsize=500;
L=13; %lags of endogenous variables
LH=3; %lags of volatility
LV=1;
CHECK=1;
maxdraws=1000;
horizon=12;
horizon1=60; %irf horizon
T0=20;
irun=0;
tarvar=4;                % this specifies the column in Y that is the threshold variable
tarD=12;                % this specifies the max delay
tarvariance=10;                % this specifies the variance of the prior for threshold value
tarscale=0.01;                % this specifies the variance of random walk proposal
tard=1:tarD;
reps=100;
scale=1;
nml=0;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55555
maxfile=372; 

file=maxfile;
 sfile=strcat(sfolder,'forecast',num2str(file),'.mat');
sfile1=strcat('irfregime1_onesd',num2str(file),'.mat');
data0=xlsread(strcat(dfolder,filesep,'datanfcismalld.xls'));
data=(data0);
Y=packr(data);
N=cols(data);
EX=((LH+1))+1;
ncrit=(N*L+EX);
X=[];
for j=1:L
X=[X lag0(data,j) ];
end
X=[X ones(rows(X),1) ];
Ystar=lag0(Y(:,tarvar),tard(1));

Y=Y(max([L,tard(1)])+1:end,:);
X=X(max([L,tard(1)])+1:end,:);
Ystar=Ystar(max([L,tard(1)])+1:end,:);





%starting value for the stochastic volatility
y=Y(T0+1:end,:);
x=X(T0+1:end,:);
Ystar=Ystar(T0+1:end,:);
data=data(T0+1:end,:);
T=rows(x);
historyY=cell(T,1);
for j=L+1:T
    historyY{j}=y(j-L+1:j,:);
end
for j=1:L
    historyY{j}=y(1:L,:);
end

 load(sfile,'amatsave1','amatsave2',...
     'bsave1','bsave2','fsave',...
     'qsave','musave','hsave',...
     'naccept','Ssave1','Ssave2','tsave','Esave');

irfmat=zeros(fsize,N,HORZ,N+1);
irfmatH=zeros(fsize,HORZ,N+1);
vmat=irfmat;
vmatH=irfmatH;
for jgibbs=1:fsize
    iamat1=squeeze(amatsave1(jgibbs,:,:));
    iamat2=squeeze(amatsave2(jgibbs,:,:));
    beta21=bsave1(jgibbs,:,:);
    beta22=bsave2(jgibbs,:,:);
fbig=squeeze(fsave(jgibbs,:,:))';
Qbig=squeeze(qsave(jgibbs,:,:))';
mubig=squeeze(musave(jgibbs,:,:))';
hlast=squeeze(hsave(jgibbs,:,:))';
hlast=hlast(2:end,:);
%history for h
historyH=cell(T,1);
for j=LH+1:T
    historyH{j}=hlast(j-LH+1:j,:);
end
for j=1:LH
    historyH{j}=hlast(1:LH,:);
end
Sbig1=squeeze(Ssave1(jgibbs,:,:));
Sbig2=squeeze(Ssave2(jgibbs,:,:));
tar=tsave(jgibbs,1);
index=tsave(jgibbs,2);
delay=tard(index);
e1=squeeze(Esave(jgibbs,:,:))';
e2=1-e1;
y1=cell(sum(e1),1);
y2=cell(sum(e2),1);
hlast1=y1;
hlast2=y2;
jj1=1;
jj2=1;
for j=1:T
    if e1(j)==1
    y1{jj1}=historyY{j};
    hlast1{jj1}=historyH{j};
    jj1=jj1+1;
    else
     y2{jj2}=historyY{j};
    hlast2{jj2}=historyH{j};
    jj2=jj2+1;  
    end
end

T1=sum(e1);
T2=sum(e2);
ir1_1=0;
ir2_1=0;
ir3_1=0;
ir4_1=0;
irh_1=0;
tic;
tmp=0;
parfor t=L+1:T1
 [t jgibbs]  
%response to level shocks in regime 1
 y0=y1{t};
    h0=hlast1{t};
    
[ ir1,ir2,ir3,ir4] = ...
    get_irfTVAR4NOTREND(N, HORZ, T, L,LH,...
    y0,h0, beta21, Sbig1,iamat1,beta22,...
    Sbig2,iamat2,tar,tarvar,delay,mubig,...
    fbig,Qbig,reps,scale,nml,EX);
  

[ irh] = ...
    get_irfTVAR4VOLNOTREND(N, HORZ, T, L,LH,...
    y0,h0, beta21, Sbig1,iamat1,beta22,...
    Sbig2,iamat2,tar,tarvar,delay,mubig,...
    fbig,Qbig,reps,scale,nml,EX);

ir1_1=ir1_1+[ir1 zeros(HORZ,1)];
ir2_1=ir2_1+[ir2 zeros(HORZ,1)];
ir3_1=ir3_1+[ir3 zeros(HORZ,1)];
ir4_1=ir4_1+[ir4 zeros(HORZ,1)];

irh_1=irh_1+irh;
tmp=tmp+1;
end

ir1_1=ir1_1/(T1-L);
ir2_1=ir2_1/(T1-L);
ir3_1=ir3_1/(T1-L);
ir4_1=ir4_1/(T1-L);
irh_1=irh_1/(T1-L);

%compute FEVD
mse=cumsum(ir1_1.^2)+cumsum(ir2_1.^2)+cumsum(ir3_1.^2)+...
    cumsum(ir4_1.^2)+cumsum(irh_1.^2);
fv1=cumsum(ir1_1.^2)./mse;
fv2=cumsum(ir2_1.^2)./mse;
fv3=cumsum(ir3_1.^2)./mse;
fv4=cumsum(ir4_1.^2)./mse;
fv5=cumsum(irh_1.^2)./mse;

irfmat(jgibbs,1,:,:)=ir1_1;
irfmat(jgibbs,2,:,:)=ir2_1;
irfmat(jgibbs,3,:,:)=ir3_1;
irfmat(jgibbs,4,:,:)=ir4_1;
irfmatH(jgibbs,:,:)=irh_1;


vmat(jgibbs,1,:,:)=fv1;
vmat(jgibbs,2,:,:)=fv2;
vmat(jgibbs,3,:,:)=fv3;
vmat(jgibbs,4,:,:)=fv4;
vmatH(jgibbs,:,:)=fv5;


 
end

save(sfile1,'irfmat','irfmatH','vmat','vmatH');

