function [b0,s0]=priorVAR_X(LAMDAP,TAUP,EPSILON,Y,L,EX,LH,EPSILONH,RW,LX,epsilonX,NX,Xf0);

N=cols(Y);

lamdaP=LAMDAP;  %This controls the tightness of the priors on the first lag
tauP=TAUP;  % this controls the tightness of the priors on sum of coefficients
epsilonP=EPSILON;  % this controls tightness of the prior on the constant
epsilonH=EPSILONH; %closer to 0 tighter prior on lagged vol in mean equations
muP=mean(Y)';
sigmaP=zeros(N,1);
deltaP=zeros(N,1);
for i=1:N
    ytemp=Y(:,i);
    xtemp=[lag0(ytemp,1) ones(rows(ytemp),1)];
    ytemp=ytemp(2:end,:);
    xtemp=xtemp(2:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if btemp(1)>1;
        btemp(1)=1;
    end
    deltaP(i)=btemp(1);
    if RW
    deltaP(i)=1;
    end
    sigmaP(i)=sqrt(stemp);
end

%dummy data to implement priors see http://ideas.repec.org/p/ecb/ecbwps/20080966.html
%[yd,xd] = create_dummies(lamdaP,tauP,deltaP,epsilonP,L,muP,sigmaP,N,LH,epsilonH);
% This create_dummies is written below

lamda=lamdaP;  % This ocntrols the tightness of the priors on first lag
tau=tauP;     % this controls the tightness of the priors on sum of coefficients
delta=deltaP;   % VAR coefficients
epsilon=epsilonP;  %   this controls tightness of the prior on the constant
p=L;               % Lags of endogenous variables
mu=muP;           % The average of data for the priors on the sum 
sigma=sigmaP;     % Std of the error terms
n=N;              % Number of endogenous variables
ph=LH;             % Contemporaneous + Lag of vol
epsilonH=epsilonH; % closer to 0 tighter prior on lagged vol in mean equations

px=LX;             % Contemporaneous + Lag of vol
epsilonX=epsilonX; % closer to 0 tighter prior on lagged vol in mean equations
nx=NX;


% Initialise output (necessary for final concatenation to work when tau=0):
x = [];
y = [];
yd1 = [];
yd2 = [];
xd1 = [];
xd2 = [];

% Get dummy matrices in equation (5) of Banbura et al. 2007:

	yd1=[diag(sigma.*delta)./lamda;
         zeros(n*(p-1),n)];
     for i=1:px*nx
         yd1=[yd1;zeros(1,n)];
     end
     
     for i=1:ph*n
         yd1=[yd1;zeros(1,n)];
     end
         
        yd1=[yd1; zeros(1,n)];
     
	jp=diag(1:p);
    
	xd1=[kron(jp,diag(sigma)./lamda)];
  
  if epsilonX>0
    for i=1:px*nx
         xd1=[[xd1 zeros(rows(xd1),1)]; [zeros(1,cols(xd1)) epsilonX]];
     end
  end
  
  if epsilonH>0
    for i=1:ph*n
         xd1=[[xd1 zeros(rows(xd1),1)]; [zeros(1,cols(xd1)) 1./sqrt(epsilonH)]];
     end
  end
  
  
  
         xd1=[[xd1 zeros(rows(xd1),1)]; [zeros(1,cols(xd1)) epsilon]];
   


% Get additional dummy matrices - see equation (9) of Banbura et al. 2007:
if tau>0
    
	yd2=diag(delta.*mu)./tau;
	%xd2=[kron(ones(1,p),yd2) zeros(n,n*ph) zeros(n,1)];

    xd2=[kron(ones(1,p),yd2) zeros(n,n*ph) zeros(n,nx*px) zeros(n,1)];
end
     
%
yd=[yd1;yd2];
% xd1
% size(xd1)
% size(xd2)
% size(kron(ones(1,p),yd2))
xd=[xd1;xd2];


 





b0=vec(xd\yd);

  b01=reshape(b0,N*L+EX,N);
  e0=yd-xd*b01;
%   S=e0'*e0;
S=diag(sigmaP.^2);
  s0=kron(S,pinv(xd'*xd));
  